--Log Format: CurrentCharacte, Timestamp, EventType (message(m) or group(g)(like party or raid)), MoreSpecificType (say, guild, instance, whisper, raid, party, etc...), sender, message, reciever (if applicable)
--ex. Gerodd, timestamp, m, guild, Gerodd, hello world
--ex. Gerodd, timestamp, m, whisper, Gerodd, hello world, Shauku
--ex. Gerodd, timestamp, g, Player1
local numLogLines
local groupIndexedYet = 0
playersInGroup = {}

--initilize mySavedVar when player logs in if it does not exist
local PlayerLogin = CreateFrame("Frame")
PlayerLogin:RegisterEvent("PLAYER_LOGIN")
PlayerLogin:SetScript("OnEvent", function(self,event,...) 
	if type(mySavedVar) ~= "table" then  --  I know it doesn't exist. so set it's default
		mySavedVar = {}
		--mySavedVar[0] = UnitName("Player")
	end
	function tableLength(T)
	  local count = 0
	  for _ in pairs(T) do count = count + 1 end
	  return count
	end
	numLogLines = tableLength(mySavedVar)
	--numLogLines = numLogLines + 1
	--ChatFrame1:AddMessage("There are " .. numLogLines .. " in the Track Interactions saved variables file")		
end)

--Say
local Say = CreateFrame("Frame")
Say:RegisterEvent("CHAT_MSG_SAY")
Say:SetScript("OnEvent", function(self,event,message,sender,...) 
	--ChatFrame1:AddMessage('I see that you have sent or recieved a message in /say and accessed numLogLines' .. numLogLines .. message .. sender .. " " .. time())
	mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() .. ", " .. time() .. ", m, say, " .. sender
	--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " say, " .. sender)
	numLogLines = numLogLines + 1
end)

--Guild
local Guild = CreateFrame("Frame")
Guild:RegisterEvent("CHAT_MSG_GUILD")
Guild:SetScript("OnEvent", function(self,event,message,sender,...) 
     	--ChatFrame1:AddMessage('I see that you have sent or recieved a message in /guild')
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, guild, " .. sender
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " guild, " .. sender)
		numLogLines = numLogLines + 1
end)

--Global ie. trade, local, etc..
local Global = CreateFrame("Frame")
Global:RegisterEvent("CHAT_MSG_CHANNEL")
Global:SetScript("OnEvent", function(self,event,message,sender,language,channelString ,...) 
     	--ChatFrame1:AddMessage('I see that you have recieved through a global channel trade, general, etc..' .. channelString  .. sender .. message)
		if string.match(channelString, "1. Trade - City") then
			mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, trade, " .. sender
			--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " general, " .. sender)
			numLogLines = numLogLines + 1
		elseif string.match(channelString, "2. General") then
			mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, general, " .. sender
			--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " trade, " .. sender)
			numLogLines = numLogLines + 1
		elseif  string.match(channelString, "3. oqchannel")  then
			
		else 
			mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, " .. channelString .. ", " .. sender
			--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. channelString .. sender)
			numLogLines = numLogLines + 1
		end
end)

--Yell
local Yell = CreateFrame("Frame")
Yell:RegisterEvent("CHAT_MSG_YELL")
Yell:SetScript("OnEvent", function(self,event,message,sender,...) 
     	--ChatFrame1:AddMessage('I see that you have recieved through a message thruogh /yell')
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, yell, " .. sender
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " yell, " .. sender)
		numLogLines = numLogLines + 1
end)	

--Raid
local Raid = CreateFrame("Frame")
Raid:RegisterEvent("CHAT_MSG_RAID")
Raid:SetScript("OnEvent", function(self,event,message,sender,...) 
     	--ChatFrame1:AddMessage('I see that you have recieved a message through /raid')
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, raid, " .. sender
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " raid, " .. sender)
		numLogLines = numLogLines + 1
end)

--Raid CHAT_MSG_RAID_LEADER
local Raid = CreateFrame("Frame")
Raid:RegisterEvent("CHAT_MSG_RAID_LEADER")
Raid:SetScript("OnEvent", function(self,event,message,sender,...) 
     	--ChatFrame1:AddMessage('I see that you have recieved a message through /raid')
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, raid, " .. sender
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " raid, " .. sender)
		numLogLines = numLogLines + 1
end)

--Raid CHAT_MSG_RAID_WARNING
local Raid = CreateFrame("Frame")
Raid:RegisterEvent("CHAT_MSG_RAID_WARNING")
Raid:SetScript("OnEvent", function(self,event,message,sender,...) 
     	--ChatFrame1:AddMessage('I see that you have recieved a message through /raid')
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, raid, " .. sender
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " raid, " .. sender)
		numLogLines = numLogLines + 1
end)

--Party
local Party = CreateFrame("Frame")
Party:RegisterEvent("CHAT_MSG_PARTY")
Party:SetScript("OnEvent", function(self,event,message,sender,...) 
     	--ChatFrame1:AddMessage('I see that you have recieved a message through /party')
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, party, " .. sender
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " party, " .. sender)
		numLogLines = numLogLines + 1
end)

--Party CHAT_MSG_PARTY_LEADER
local Party = CreateFrame("Frame")
Party:RegisterEvent("CHAT_MSG_PARTY_LEADER")
Party:SetScript("OnEvent", function(self,event,message,sender,...) 
     	--ChatFrame1:AddMessage('I see that you have recieved a message through /party')
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, party, " .. sender
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " party, " .. sender)
		numLogLines = numLogLines + 1
end)

--Instance CHAT_MSG_INSTANCE_CHAT
local Instance = CreateFrame("Frame")
Instance:RegisterEvent("CHAT_MSG_INSTANCE_CHAT")
Instance:SetScript("OnEvent", function(self,event,message,sender,...) 
     	--ChatFrame1:AddMessage('I see that you have recieved a message in /i')
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, instance, " .. sender
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " instance, " .. sender)
		numLogLines = numLogLines + 1
end)

--Instance CHAT_MSG_INSTANCE_CHAT_LEADER
local Instance = CreateFrame("Frame")
Instance:RegisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
Instance:SetScript("OnEvent", function(self,event,message,sender,...) 
     	--ChatFrame1:AddMessage('I see that you have recieved a message in /i')
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, instance, " .. sender
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " instance, " .. sender)
		numLogLines = numLogLines + 1
end)


--Send Whisper
local WhisperSend = CreateFrame("Frame")
WhisperSend:RegisterEvent("CHAT_MSG_WHISPER_INFORM")
WhisperSend:SetScript("OnEvent", function(self,event,message,sender,language,channelString,target,...) 
     	--ChatFrame1:AddMessage('I see that you have sent a whisper message to ' .. target)
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, whisper, to " .. target
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " whisper, to " .. target)
		numLogLines = numLogLines + 1
end)

--RecieveWhisper
local WhisperRecieve = CreateFrame("Frame")
WhisperRecieve:RegisterEvent("CHAT_MSG_WHISPER")
WhisperRecieve:SetScript("OnEvent", function(self,event,message,sender,language,channelString,target,...) 
     	--ChatFrame1:AddMessage('I see that you have recieved a whisper message from ' .. sender)
		mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, whisper, from " .. sender
		--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " whisper, from " .. sender)
		numLogLines = numLogLines + 1
end)

--Maybe i wont track battle net communications because they can include real names
--Send Whisper over battle.net
--local WhisperBNSend = CreateFrame("Frame")
--WhisperBNSend:RegisterEvent("CHAT_MSG_BN_WHISPER_INFORM")
--WhisperBNSend:SetScript("OnEvent", function(self,event,...) 
--     	ChatFrame1:AddMessage('I see that you have sent a whisper message through BattleNet')
--end)

--Recieve Whisper over battle.net
--local WhisperBNRecieve = CreateFrame("Frame")
--WhisperBNRecieve:RegisterEvent("CHAT_MSG_BN_WHISPER")
--WhisperBNRecieve:SetScript("OnEvent", function(self,event,...) 
--    	ChatFrame1:AddMessage('I see that you have recieved a whisper message through BattleNet')
--end)

--Group Interaction
local GroupInteraction = CreateFrame("Frame")
GroupInteraction:RegisterEvent("GROUP_ROSTER_UPDATE")
GroupInteraction:SetScript("OnEvent", function(self,event,message,sender,language,channelString,target,...) 
     	--ChatFrame1:AddMessage('I see that you have entered a group' )
		if groupIndexedYet == 0 then
			for i = 1, GetNumGroupMembers() do
				--ChatFrame1:AddMessage("No group has been indexed yet... indexing...")
				local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, loot = GetRaidRosterInfo(i)
				--ChatFrame1:AddMessage("Group Member: " .. name)
				playersInGroup[i] = name	
			end
			groupIndexedYet = 1
		elseif groupIndexedYet == 1 then
			--ChatFrame1:AddMessage("There already is a group indexed")
			tmpArray = {}
			for i = 1, GetNumGroupMembers() do
				local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, loot = GetRaidRosterInfo(i)
				--ChatFrame1:AddMessage("Group Member: " .. name)
				tmpArray[i] = name	
			end	
			for index1 = 1, table.getn(tmpArray) do
			--	ChatFrame1:AddMessage("Looking for " .. tmpArray[index1] .. " in already indexed players")
				local isPlayerFound = 0
				for index2 = 1, table.getn(playersInGroup) do
					if tmpArray[index1] == playersInGroup[index2] then
						--ChatFrame1:AddMessage("Found: " .. tmpArray[index1] .. " in already indexed players " .. playersInGroup[index2])
						isPlayerFound = 1
					end
				end
				if isPlayerFound == 0 then
					--ChatFrame1:AddMessage("Did not find " .. tmpArray[index1] .." in already indexed players, them must be added to index")
					local tmpCounter = table.getn(playersInGroup)
					--ChatFrame1:AddMessage("Num Group Member: " .. table.getn(playersInGroup))
					tmpCounter = tmpCounter + 1
					--ChatFrame1:AddMessage("Adding " .. tmpArray[index1] .. " to index with index num " .. tmpCounter )
					playersInGroup[tmpCounter] = tmpArray[index1]
				end
			end
		else
			 error("Something must have broke")
		end
		for tmpi = 1,  table.getn(playersInGroup) do
			--ChatFrame1:AddMessage("Stuff From Array: " .. playersInGroup[tmpi])
		end
		--mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", m, whisper, " .. sender .. " to " .. target .. " , ".. message
		--numLogLines = numLogLines + 1
end)



local PlayerEnterWorld = CreateFrame("Frame")
PlayerEnterWorld:RegisterEvent("PLAYER_ENTERING_WORLD")
PlayerEnterWorld:SetScript("OnEvent", function(self,event,...)
	if table.getn(playersInGroup) > 0 then
		for i = 1, table.getn(playersInGroup) do
			if playersInGroup[i] == nil then
				--ChatFrame1:AddMessage("**Found a nil variable, skipping")
			else
				mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", g, " .. playersInGroup[i]
				--ChatFrame1:AddMessage("Logging: LogLines: " .. numLogLines .. " " .. time() .. " " .. playersInGroup[i])
				numLogLines = numLogLines + 1
			end
		end
	end
	playersInGroup = {}
	groupIndexedYet = 0
end)


-- local PlayerLogout = CreateFrame("Frame")
-- PlayerLogout:RegisterEvent("PLAYER_LOGOUT")
-- PlayerLogout:SetScript("OnEvent", function(self,event,...) 
	-- for i = 1, table.getn(playersInGroup) do
		-- mySavedVar[numLogLines] = UnitName("Player") .. "-" .. GetRealmName() ..  ", " .. time() .. ", g, " .. playersInGroup[i]
		-- numLogLines = numLogLines + 1
	-- end
-- end)
